// prefdlg.cpp : implementation file
// Copyright 2002 by Jon Dart. All Rights Reserved.

#include "stdafx.h"
#include "prefdlg.h"

#include "arasan.h"

#include <stdio.h>

/////////////////////////////////////////////////////////////////////////////
// PreferenceDialog dialog


PreferenceDialog::PreferenceDialog(CWnd* pParent /*=NULL*/)
	: CDialog(PreferenceDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(PreferenceDialog)
	m_AutoSizeHashTable = FALSE;
	m_HashSize = 0;
	m_Ponder = FALSE;
    m_BeepOnError = FALSE;
	m_ShowCoord = FALSE;
    m_BeepAfterMove = FALSE;
	m_CanResign = FALSE;
	//}}AFX_DATA_INIT
    m_AutoSizeHashTable = guiOptions->auto_size_hash_table();
    m_HashSize = guiOptions->hash_table_size();
    m_Ponder = guiOptions->think_when_idle();
    m_BeepOnError = guiOptions->beep_on_error();
    m_BeepAfterMove = guiOptions->beep_after_move();
    m_ShowCoord = guiOptions->show_coordinates();
    m_CanResign = guiOptions->can_resign();
}


void PreferenceDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(PreferenceDialog)
	DDX_Control(pDX, IDC_AUTO_SIZE, m_AutoSizeCheck);
	DDX_Control(pDX, IDC_HASH_SIZE_EDIT, m_HashSizeEdit);
	DDX_Check(pDX, IDC_AUTO_SIZE, m_AutoSizeHashTable);
	DDX_Text(pDX, IDC_HASH_SIZE_EDIT, m_HashSize);
	DDV_MinMaxUInt(pDX, m_HashSize, 0, 500);
	DDX_Check(pDX, IDC_PONDER_CHECK, m_Ponder);
    DDX_Check(pDX, IDC_BEEP_ON_ERROR_CHECK, m_BeepOnError);
	DDX_Check(pDX, IDC_SHOW_COORD_CHECK, m_ShowCoord);
	DDX_Check(pDX, IDC_BEEP_AFTER_MOVE_CHECK, m_BeepAfterMove);
	DDX_Check(pDX, IDC_CAN_RESIGN_CHECK, m_CanResign);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(PreferenceDialog, CDialog)
	//{{AFX_MSG_MAP(PreferenceDialog)
	ON_BN_CLICKED(IDC_AUTO_SIZE, OnAutoSize)
	ON_NOTIFY(UDN_DELTAPOS, IDC_HASH_SIZE_SPIN, OnDeltaposHashSizeSpin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void PreferenceDialog::save() {
    GeneralPreferences prefs;
    guiOptions->getGeneralPreferences(prefs);
    prefs.beep_on_error = m_BeepOnError;
    prefs.beep_after_move = m_BeepAfterMove;
    prefs.think_when_idle = m_Ponder;
    prefs.hash_table_size = m_HashSize;
    prefs.auto_size_hash_table = m_AutoSizeHashTable;
    prefs.can_resign = m_CanResign;
    guiOptions->setGeneralPreferences(prefs);
}

/////////////////////////////////////////////////////////////////////////////
// PreferenceDialog message handlers

void PreferenceDialog::OnAutoSize() 
{
    UpdateData();
    if (m_AutoSizeHashTable) {
       int val = calc_hash_size();
       char valStr[20];
       sprintf(valStr,"%d",val);
       m_HashSizeEdit.EnableWindow(FALSE);
       m_HashSizeEdit.SetWindowText(valStr);
    }
    else
        m_HashSizeEdit.EnableWindow(TRUE);
}

void PreferenceDialog::OnDeltaposHashSizeSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

BOOL PreferenceDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    OnAutoSize();	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
