#ifndef _BOARDHASH_H_
#define _BOARDHASH_H_

#include "board.h"
#include "debug.h"

extern const hash_t hash_codes[64][16];
extern const hash_t ep_codes[64];
extern const hash_t b_castle_status[6];
extern const hash_t w_castle_status[6];

class BoardHash
{
	public:
		
	static void free();
	
	static hash_t hashCode(const Board &);
	
        static hash_t pawnHash(const Board &);

        static hash_t Xor( hash_t h, const Square sq, const Piece piece )
        {
           ASSERT(OnBoard(sq));
           return h ^ hash_codes[sq][(int)piece];
        }

        static hash_t kingPawnHash(const Board &b)
        {
           return Xor(Xor(b.pawn_hash(), b.KingPos(White), King), b.KingPos(Black), King);
        }
};

#endif

